#include <windows.h>
#include <tchar.h>
#include <d3d9.h>

IDirect3D9				*pD3D = 0;
IDirect3DDevice9		*pD3DDevice = 0;

HRESULT hr;

void Render()
{
	pD3DDevice->Clear(
		0,
		NULL,
		D3DCLEAR_TARGET,
		D3DCOLOR_XRGB( 50, 40, 30 ),
		1.0f,
		0 );

	pD3DDevice->Present( NULL, NULL, NULL, NULL );
}

LRESULT WINAPI WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
		case WM_DESTROY:
			PostQuitMessage( 0 );
			return 0;
		case WM_PAINT:
			ValidateRect( hWnd, NULL );
			Render();
			return 0;
	}

	return DefWindowProc( hWnd, msg, wParam, lParam );
}


int WINAPI _tWinMain( HINSTANCE hInstance, HINSTANCE, LPTSTR, INT )
{
	// Tworzenie okna:
	WNDCLASSEX wc;
	ZeroMemory( &wc, sizeof( WNDCLASSEX ) );
	wc.cbSize = sizeof( WNDCLASSEX );
	wc.style = CS_CLASSDC;
	wc.lpfnWndProc = WndProc;
	wc.hInstance = hInstance;
	wc.lpszClassName = _T( "LabiryntWndClass" );
	RegisterClassEx( &wc );

	HWND hWnd = CreateWindow(
		_T( "LabiryntWndClass" ),
		_T( "Trjwymiarowy labirynt ;)" ),
		WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT, CW_USEDEFAULT,
		800, 600,
		NULL, NULL,
		hInstance,	
		NULL );



	//	Direct3D:
	pD3D = Direct3DCreate9( D3D_SDK_VERSION );
	if(!pD3D) goto WinMain_end;

    D3DPRESENT_PARAMETERS d3dpp;
    ZeroMemory( &d3dpp, sizeof( d3dpp ) );
    d3dpp.Windowed = TRUE;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;

	
    hr = pD3D->CreateDevice(
		D3DADAPTER_DEFAULT,
		D3DDEVTYPE_HAL,
		hWnd,
		D3DCREATE_HARDWARE_VERTEXPROCESSING,
		&d3dpp,
		&pD3DDevice );
	if( FAILED( hr ) ) goto WinMain_end;

	
	//	Wywietl okno:
	ShowWindow( hWnd, SW_SHOWDEFAULT );


	//	Ptla komunikatw i renderowania:
	MSG msg;
	while( GetMessage( &msg, NULL, 0U, 0U ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}


	//	Do tego bloku mona wej tylko poprzez instrukcj goto:
	if(0)
	{
		WinMain_end:
		msg.wParam = 1;
	}

	//	Zwalniamy interfejsy Direct3D:
	if( pD3DDevice ) pD3DDevice->Release();
    if( pD3D ) pD3D->Release();

	//	Wyrejestrowanie klasy okna:
	UnregisterClass( _T("LabiryntWndClass"), hInstance );

	//	Zwracamy warto komunikatu WM_QUIT lub 1, jeli wykonane zostao goto:
	return msg.wParam;
}



